//	ToneFactory.cpp - Singleton class used to construct new Tones.
//  ----------------------------------------------------------------------------
//	This file is part of 'GameTemplate', template code for a game.
//	Copyright (C) 2011  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "TonesSounder.h"
#include "ToneFactory.h"

using namespace std;

//------------------------------------------------------------------------------
ToneFactory& ToneFactory::getInstance()
{
	static ToneFactory retval;

	return retval;
}

//------------------------------------------------------------------------------
shared_ptr<Tone> ToneFactory::getTone(const wstring& name,
									  int startRail,
									  int startNumRails,
									  shared_ptr<TonesSounder>& sounder)
{
	return creators[name]->createTone(startRail, startNumRails, sounder);
}

//------------------------------------------------------------------------------
void ToneFactory::registerNormalToneCreator(const wstring& name,
											shared_ptr<ToneCreator> creator)
{
	creators.insert(make_pair(name, creator));
	normalVector.push_back(creator);
}

//------------------------------------------------------------------------------
void ToneFactory::registerSpecialToneCreator(const wstring& name,
											 shared_ptr<ToneCreator> creator)
{
	creators.insert(make_pair(name, creator));
	specialVector.push_back(creator);
}

//------------------------------------------------------------------------------
ToneFactory::ToneFactory()
{

}

//------------------------------------------------------------------------------
ToneFactory::~ToneFactory()
{

}
